/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef ARTSFLOW_H
#define ARTSFLOW_H

#include "common.h"

enum PortDirection {input = 0, output = 1};
enum PortDataType {audio_data = 0, string_data = 1};
enum PortConnType {conn_stream = 0, conn_event = 1, conn_property = 2};
class PortType : public Type {
public:
	PortType();
	PortType(PortDirection Direction, PortDataType DataType, PortConnType ConnType, bool isMultiPort);
	PortType(Buffer& stream);
	PortType(const PortType& copyType);
	PortType& operator=(const PortType& assignType);
	virtual ~PortType();

	PortDirection Direction;
	PortDataType DataType;
	PortConnType ConnType;
	bool isMultiPort;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class PortDesc : public Type {
public:
	PortDesc();
	PortDesc(long ID, const std::string& Name, const PortType& Type, bool isConnected, bool hasValue, const std::vector<long>& ConnectedIDs, float FloatValue, const std::string& StringValue);
	PortDesc(Buffer& stream);
	PortDesc(const PortDesc& copyType);
	PortDesc& operator=(const PortDesc& assignType);
	virtual ~PortDesc();

	long ID;
	std::string Name;
	PortType Type;
	bool isConnected;
	bool hasValue;
	std::vector<long> ConnectedIDs;
	float FloatValue;
	std::string StringValue;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class ModuleDesc : public Type {
public:
	ModuleDesc();
	ModuleDesc(long ID, const std::string& Name, const std::vector<PortDesc *>& Ports, long X, long Y, long Width, long Height, bool isInterface, bool isStructure);
	ModuleDesc(Buffer& stream);
	ModuleDesc(const ModuleDesc& copyType);
	ModuleDesc& operator=(const ModuleDesc& assignType);
	virtual ~ModuleDesc();

	long ID;
	std::string Name;
	std::vector<PortDesc *> Ports;
	long X;
	long Y;
	long Width;
	long Height;
	bool isInterface;
	bool isStructure;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class StructureDesc : public Type {
public:
	StructureDesc();
	StructureDesc(long Width, long Height, const std::vector<ModuleDesc *>& Modules, const std::string& Name, bool containsStructures);
	StructureDesc(Buffer& stream);
	StructureDesc(const StructureDesc& copyType);
	StructureDesc& operator=(const StructureDesc& assignType);
	virtual ~StructureDesc();

	long Width;
	long Height;
	std::vector<ModuleDesc *> Modules;
	std::string Name;
	bool containsStructures;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class ArtsServer : virtual public Object {
public:
	static ArtsServer *_fromString(std::string objectref);
	static ArtsServer *_fromReference(ObjectReference ref, bool needcopy);

	inline ArtsServer *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual long createModules() = 0;
	virtual bool createModule(long mid, const ModuleDesc& desc) = 0;
	virtual bool localConnectModules(long mid) = 0;
	virtual bool finalizeModules(long mid) = 0;
	virtual void startModules(long mid) = 0;
	virtual void deleteModules(long mid) = 0;
};

typedef ReferenceHelper<ArtsServer> ArtsServer_var;

class ArtsServer_stub : virtual public ArtsServer, virtual public Object_stub {
protected:
	ArtsServer_stub();

public:
	ArtsServer_stub(Connection *connection, long objectID);

	long createModules();
	bool createModule(long mid, const ModuleDesc& desc);
	bool localConnectModules(long mid);
	bool finalizeModules(long mid);
	void startModules(long mid);
	void deleteModules(long mid);
};

class ArtsServer_skel : virtual public ArtsServer, virtual public Object_skel {
public:
	ArtsServer_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class ExecutionManager : virtual public Object {
public:
	static ExecutionManager *_fromString(std::string objectref);
	static ExecutionManager *_fromReference(ObjectReference ref, bool needcopy);

	inline ExecutionManager *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual StructureDesc* expandStructureDesc(const StructureDesc& structuredesc) = 0;
	virtual long createStructure(const StructureDesc& structuredesc) = 0;
	virtual bool isExecuting(long id) = 0;
	virtual bool freeStructure(long id) = 0;
	virtual void forceTermination() = 0;
};

typedef ReferenceHelper<ExecutionManager> ExecutionManager_var;

class ExecutionManager_stub : virtual public ExecutionManager, virtual public Object_stub {
protected:
	ExecutionManager_stub();

public:
	ExecutionManager_stub(Connection *connection, long objectID);

	StructureDesc* expandStructureDesc(const StructureDesc& structuredesc);
	long createStructure(const StructureDesc& structuredesc);
	bool isExecuting(long id);
	bool freeStructure(long id);
	void forceTermination();
};

class ExecutionManager_skel : virtual public ExecutionManager, virtual public Object_skel {
public:
	ExecutionManager_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class SynthModule : virtual public Object {
public:
	static SynthModule *_fromString(std::string objectref);
	static SynthModule *_fromReference(ObjectReference ref, bool needcopy);

	inline SynthModule *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual void firstInitialize() = 0;
	virtual void initialize() = 0;
	virtual void start() = 0;
	virtual void deInitialize() = 0;
};

typedef ReferenceHelper<SynthModule> SynthModule_var;

class SynthModule_stub : virtual public SynthModule, virtual public Object_stub {
protected:
	SynthModule_stub();

public:
	SynthModule_stub(Connection *connection, long objectID);

	void firstInitialize();
	void initialize();
	void start();
	void deInitialize();
};

class SynthModule_skel : virtual public SynthModule, virtual public Object_skel {
public:
	SynthModule_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_PLAY : virtual public SynthModule {
public:
	static Synth_PLAY *_fromString(std::string objectref);
	static Synth_PLAY *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_PLAY *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_PLAY> Synth_PLAY_var;

class Synth_PLAY_stub : virtual public Synth_PLAY, virtual public SynthModule_stub {
protected:
	Synth_PLAY_stub();

public:
	Synth_PLAY_stub(Connection *connection, long objectID);

};

class Synth_PLAY_skel : virtual public Synth_PLAY, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *invalue_left;                      // incoming stream
	float *invalue_right;                     // incoming stream

public:
	Synth_PLAY_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_FREQUENCY : virtual public SynthModule {
public:
	static Synth_FREQUENCY *_fromString(std::string objectref);
	static Synth_FREQUENCY *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_FREQUENCY *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_FREQUENCY> Synth_FREQUENCY_var;

class Synth_FREQUENCY_stub : virtual public Synth_FREQUENCY, virtual public SynthModule_stub {
protected:
	Synth_FREQUENCY_stub();

public:
	Synth_FREQUENCY_stub(Connection *connection, long objectID);

};

class Synth_FREQUENCY_skel : virtual public Synth_FREQUENCY, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *frequency;                         // incoming stream
	float *pos;                               // outgoing stream

public:
	Synth_FREQUENCY_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_WAVE_SIN : virtual public SynthModule {
public:
	static Synth_WAVE_SIN *_fromString(std::string objectref);
	static Synth_WAVE_SIN *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_WAVE_SIN *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_WAVE_SIN> Synth_WAVE_SIN_var;

class Synth_WAVE_SIN_stub : virtual public Synth_WAVE_SIN, virtual public SynthModule_stub {
protected:
	Synth_WAVE_SIN_stub();

public:
	Synth_WAVE_SIN_stub(Connection *connection, long objectID);

};

class Synth_WAVE_SIN_skel : virtual public Synth_WAVE_SIN, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *pos;                               // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_WAVE_SIN_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_MULTI_ADD : virtual public SynthModule {
public:
	static Synth_MULTI_ADD *_fromString(std::string objectref);
	static Synth_MULTI_ADD *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_MULTI_ADD *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_MULTI_ADD> Synth_MULTI_ADD_var;

class Synth_MULTI_ADD_stub : virtual public Synth_MULTI_ADD, virtual public SynthModule_stub {
protected:
	Synth_MULTI_ADD_stub();

public:
	Synth_MULTI_ADD_stub(Connection *connection, long objectID);

};

class Synth_MULTI_ADD_skel : virtual public Synth_MULTI_ADD, virtual public SynthModule_skel {
protected:
	// variables for streams
	float **invalue;                          // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_MULTI_ADD_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_ADD : virtual public SynthModule {
public:
	static Synth_ADD *_fromString(std::string objectref);
	static Synth_ADD *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_ADD *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_ADD> Synth_ADD_var;

class Synth_ADD_stub : virtual public Synth_ADD, virtual public SynthModule_stub {
protected:
	Synth_ADD_stub();

public:
	Synth_ADD_stub(Connection *connection, long objectID);

};

class Synth_ADD_skel : virtual public Synth_ADD, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *invalue1;                          // incoming stream
	float *invalue2;                          // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_ADD_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_MUL : virtual public SynthModule {
public:
	static Synth_MUL *_fromString(std::string objectref);
	static Synth_MUL *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_MUL *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_MUL> Synth_MUL_var;

class Synth_MUL_stub : virtual public Synth_MUL, virtual public SynthModule_stub {
protected:
	Synth_MUL_stub();

public:
	Synth_MUL_stub(Connection *connection, long objectID);

};

class Synth_MUL_skel : virtual public Synth_MUL, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *invalue1;                          // incoming stream
	float *invalue2;                          // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_MUL_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

class Synth_PLAY_WAV : virtual public SynthModule {
public:
	static Synth_PLAY_WAV *_fromString(std::string objectref);
	static Synth_PLAY_WAV *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_PLAY_WAV *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual float speed() = 0;
	virtual void speed(float newValue) = 0;
	virtual std::string filename() = 0;
	virtual void filename(const std::string& newValue) = 0;
	virtual bool finished() = 0;
};

typedef ReferenceHelper<Synth_PLAY_WAV> Synth_PLAY_WAV_var;

class Synth_PLAY_WAV_stub : virtual public Synth_PLAY_WAV, virtual public SynthModule_stub {
protected:
	Synth_PLAY_WAV_stub();

public:
	Synth_PLAY_WAV_stub(Connection *connection, long objectID);

	float speed();
	void speed(float newValue);
	std::string filename();
	void filename(const std::string& newValue);
	bool finished();
};

class Synth_PLAY_WAV_skel : virtual public Synth_PLAY_WAV, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *left;                              // outgoing stream
	float *right;                             // outgoing stream

public:
	Synth_PLAY_WAV_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#endif /* ARTSFLOW_H */
